/*
 * ListsView.java
 *
 * Created on 10 de agosto de 2004, 17:53
 */

package com.fenalco.servlets.shopkeeper;

import java.io.IOException;

import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.ShoppingListList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.ShoppingListListView;

/**
 * Esta clase es la encargada de cargar las listas de compra asociadas con el
 * minorista que van a ser presentadas en el JSP mislistas.jsp .
 * 
 * @author Mario Linares Vásquez
 */
public class ListsView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destructor del servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Este método procesa las solicitudes para los métodos HTTP
	 * <code>GET</code> y <code>POST</code>. Debe crear una instancia de la
	 * clase <CODE>ShoppingListList</CODE> (con el id del usuario que reside
	 * en la sesión) y luego su respectiva vista <CODE>ShoppingListView</CODE>
	 * que será enviada al JSP mislistas.jsp a través del response como atributo
	 * llamado view
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{

		String url = "/minorista/mislistas.jsp";
        HttpSession session = request.getSession( false );
        String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 3 )
			{
				message = MessageBuilder.buildMessage(15);
				url = "/index.jsp";
			}
			else
			{
				if(request.getAttribute("message") != null){
                                    message = (String)request.getAttribute("message");
                                }
                                // criterios de paginación
				int page = 1;
				int pageResults = 20;
				int pages = 0; // numero total de páginas
				int firstRow = 0; // numero del primero registro que se va a mostrar
				int lastRow = 19; // numero del último registro que se va a mostrar
				int total = 0; // numero total de resultados
                            
                                String slName = request.getParameter("name");
                                
                                int companyId = ((User) request.getSession().getAttribute("user"))
				.getCompanyId();
				ShoppingListList list = new ShoppingListList(companyId);
                                
                                
                                 //filtrar para el buscador
                                if(slName != null){
                                    list.filterByName(slName);
                                }
                                else{
                                    slName = "";
                                }
                                
	
                                
                                // aqui se efectua la paginación
                                if(request.getParameter("page")!=null){
                                    try{
                                        page = Integer.parseInt(request.getParameter("page"));
                                    }catch(NumberFormatException nfe){
                                        page = 1;
                                    }    
                                    page = (page < 1) ? 1 : page;
                                    try{
                                        pageResults = Integer.parseInt(request.getParameter("pageResults"));
                                    }catch(NumberFormatException nfe){
                                        pageResults = 20;
                                    }
                                    pageResults = (pageResults < 1) ? 20 : pageResults;
                                }
                                
                                total = list.getShoppingLists().size();
                                pages = (int) Math.ceil((double) total / (double) pageResults);
                                if( page > pages ){
                                        page = pages;
                                }
                                firstRow = (page - 1) * pageResults;
                                lastRow = page * pageResults;
                                firstRow = (firstRow < 0) ? 0 : firstRow;
                                if( lastRow > total ){
                                        lastRow = total;
                                }

                                Vector temp = new Vector();
                                for( int i = 0; i < total; i++ ){
                                        if( i >= firstRow && i <= lastRow - 1 ){
                                                temp.addElement(list.getShoppingLists().elementAt(i));
                                        }
                                }

                                list.setShoppingLists(temp);
                                
                                
                                
                                
				ShoppingListListView view = new ShoppingListListView(list);
		
				request.setAttribute("view", view);
                                
                                request.setAttribute( "name", slName );
                                
                                /// información de la paginacion
				firstRow++; // para no arrancar desde 0
				firstRow = (lastRow == 0) ? 0 : firstRow;
				request.setAttribute("firstRow", firstRow + "");
				request.setAttribute("lastRow", lastRow + "");
				request.setAttribute("total", total + "");
				request.setAttribute("page", page + "");
				request.setAttribute("pages", pages + "");
				request.setAttribute("pageResults", pageResults + "");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		RequestDispatcher dispatcher = getServletContext()
				.getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Returna una breve descripción del servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}